/*:
CC -O -c OpenTable.c -o OpenTable.o
ar -r TabText.a OpenTable.o
del OpenTable.o
*/
#include "defTable.h"

Table OpenTable(char *name)
{ char *a, **aa, *b, *d, *c, *cc;
  size_t l, ll, ls, lT=0, lA=EXTRA, asp=0, lLine, *col;
  FILE *file;
  Table ff;
  
  ff.Col=(size_t*)Alloc(sizeof(size_t)*COLMAX),
  ff.Output=Alloc(lOUTPUT),
  aa=ff.Table=(char**)Alloc(sizeof(char*)*lA),
  ff.lTable=ff.asp=0, ff.lFree=lA-1;
  if( !name ) return ff;
  col=ff.Col, a=ff.Output;
  b=d=Alloc(lOUTPUT), file=stdin;
  if( *name )
    if( !(file=fopen(name, "r")) )
    { fprintf(stderr, "*** Open error: %s\n", name); 
      return ff;
    }
  fgets(a, lOUTPUT, file),
  ls=strlen(a)-1;
  if( *(a+ls)=='\n' ) *(a+ls)=0;
  while( *a )
  { c=a+strspn(a, " ");
    cc=c+strcspn(c, " "), l=cc-a, ll=cc-c, memcpy(b, c, ll),
    *(b+ll)=0, b+=l+1, col++, 
    *col=*(col-1)+l+1, asp++, a=cc+1;
  }
  if( !asp )
    fprintf(stderr, "*** no column structure %s\n", name),
    Return(1);
  ff.asp=asp, lLine=*col, *aa=Alloc(lLine), 
  memcpy(*aa, d, lLine),
  ff.lTable=1, ff.lFree=lA-2, a=ff.Output, *a=0;
  while(fgets(a, (int)lLine, file)) AppendRow(&ff, a), *a=0;
  return ff;
}

Table OpenTable(Text *f, char *head)
{ char *a, **aa, *b, w[8], *z;
  size_t k, i, l, asp=0, lA=EXTRA, *col;
  Table ff=OpenTable();
  
  if( !f->lText || !ResetText(f) ) return ff;
  if( *head )
  { InsertLine(f, head), ResetText(f), CloseTable(&ff),
    ff=OpenTable(f,""), DeleteRow(&ff, 0), DeleteLine(f,1);
    return ff;
  }
  strcpy(f->Ignore, " "), f->Line=f->Word=f->Text, k=0;
  while( *f->Line )
  { col=ff.Col, k++, i=0;
    while( l=GetWordinLine(f) )
    { col++, i++, l++;
      if( l>*col ) *col=l;
    }
    NextLine(f);
    if( i>asp ) asp=i;
  }
  strcpy(f->Ignore, IGNORE), col=ff.Col, ff.asp=asp;
  while( asp-- ) *(col+1)+=*col, col++;
  if( lA<k )
    Free(ff.Table), lA=k+EXTRA,
    aa=ff.Table=(char**)Alloc(sizeof(char*)*lA),
    ff.lFree=--lA;
  asp=ff.asp, aa=ff.Table, b=*aa=Alloc(*col), i=1, col=ff.Col;
  while( asp-- )
    l=*(col+1)-*col-1, sprintf(w,"%i",i), strcpy(b, w),
    i++, col++, b+=l+1;
  aa++, z=f->Line=f->Word=f->Text, ff.lTable=1;
  while( *z )
  { a=strchr(z, '\n'), *a=0, AppendRow(&ff, z), 
    *a='\n', z=a+1;
  }
  return ff;
}
