/*:
CC -O -c OpenText.c -o OpenText.o
ar -r TabText.a OpenText.o
del OpenText.o 
*/
#include <sys/stat.h>
#include "defTable.h"

Text OpenText(char *name)
{ struct stat statb;
  Text f;
  char *a;
  size_t l, lT, lA=EXTRA, lIGNORE=strlen(IGNORE);
  FILE *file;
  
  memset(&f, 0, sizeof(f)), f.Ignore=Alloc(lIGNORE+lOUTPUT),
  f.Output=f.Ignore+lIGNORE, strcpy(f.Ignore, IGNORE), 
  f.Line=f.Word=f.Text=Alloc(lA), 
  lA--, f.lFree=lA;
  if( !name ) return f;
  a=f.Output; 
  if( *name )
  { stat(name,&statb);
    if( !(lT=statb.st_size) ) return f;
    if( !(file=fopen(name,"r")) )
      fprintf(stderr, "*** Open error: %s\n", name), exit(1);
    Free(f.Text), a=Alloc(lA+=lT);
    if( !(l=fread(a ,1, lT, file)) )
    { fprintf(stderr, "*** Read error: %s\n", name), Free(a);
      return f;
    }
    if( *(a+l-1)!='\n' ) 
      *(a+l)='\n', l++, *(a+l)=0;
    fclose(file), f.Text=a, f.lText=l, 
    f.lFree=lA-l;
  }
  else 
    while( gets(a) ) AppendLine(&f, a);
  f.Line=f.Word=f.Text;
  return f;
}

Text OpenText(Table *f)
{ Text ff=OpenText();
  size_t l=f->lTable, i=0;
  
  if( !l ) return ff;
  while( i<l ) 
    RowToLine(f, i), AppendLine(&ff, f->Output), i++;
  ResetText(&ff);
  return ff;
}
