#define COLMAX  128  // Spalten-Anzahl
#include "defText.h"

typedef struct TableStruct
        { size_t lTable,       // Zeilen-Anzahl
                 lFree,        // Anzahl der Freipltze
                 asp,          // Spalten-Anzahl
                 *Col;         // relative Spalten-Anfnge
            char **Table,      // Zeilen-Anfangszeiger
                 *Output;      // Ausgabe fr Zeile/Eintrag
        } Table;
        
extern Table OpenTable(char* =0);
extern Table OpenTable(Text*, char* ="");
extern Table CreateTable(char*);
extern Table CopyTable(Table*);
extern void CloseTable(Table*);
extern unsigned char PrintTable(Table*, char* ="", char* ="w+");
extern unsigned char ChangeColumnWidth(Table*, size_t, size_t);
extern unsigned char ChangeColumnWidth(Table*, char*, size_t);
extern unsigned char SetColumnWidth(Table*);
extern size_t GetColumnWidth(Table*, size_t);
extern Table GetRow(Table*, size_t, size_t =1);
extern Table GetRow(Table*, size_t, char*);
extern Table GetRow(Table*, char*, char*);
extern Table GetColumn(Table*, size_t, size_t =1);
extern Table GetColumn(Table*, char*);
extern char* GetEntry(Table*, size_t, size_t);
extern unsigned char PutEntry(Table*, size_t, size_t, char*);
extern unsigned char PutEntry(Table*, size_t, char*, char*);
extern unsigned char PutColumn(Table*, size_t, Table*, size_t =1, size_t =1);
extern unsigned char PutColumn(Table*, char*, Table*, char*);
extern unsigned char PutColumn(Table*, size_t, char*);
extern unsigned char PutColumn(Table*, char*, char*);
extern unsigned char PutRow(Table*, size_t, Table*, size_t =0, size_t =1);
extern unsigned char AppendRow(Table*, Table*, size_t, size_t =1);
extern unsigned char AppendRow(Table*, char*);
extern unsigned char AppendColumn(Table*, Table*, size_t, size_t =1);
extern unsigned char InsertRow(Table*, size_t, char*);
extern unsigned char InsertColumn(Table*, size_t, Table*, size_t, size_t =1);
extern unsigned char InsertColumn(Table*, char*, Table*, char*);
extern unsigned char InsertColumn(Table*, size_t, char*);
extern unsigned char InsertColumn(Table*, char*, char*);
extern Table JoinTable(Table*, size_t, Table*, size_t, size_t =1);
extern Table JoinTable(Table*, char*, Table*, char*);
extern unsigned char DeleteRow(Table*, size_t, size_t =1);
extern unsigned char DeleteDoubleRow(Table*, size_t);
extern unsigned char DeleteColumn(Table*, size_t, size_t =1);
extern unsigned char DeleteColumn(Table*, char*);
extern unsigned char DeleteDoubleColumn(Table*);
extern unsigned char SwapRow(Table*, size_t, size_t);
extern unsigned char SwapColumn(Table*, size_t, size_t);
extern unsigned char SwapColumn(Table*, char*, char*);
extern size_t ColumnToLine(Table*, size_t);
extern size_t ColumnToLine(Table*, char*);
extern size_t RowToLine(Table*, size_t);
extern size_t SearchColumn(Table*, char*);
extern unsigned char SortTable(Table*, size_t);
extern unsigned char SortTable(Table*, char*);
extern unsigned char SortTableInvers(Table*, size_t);
extern unsigned char SortTableInvers(Table*, char*);
extern unsigned char SortTableNum(Table*, size_t);
extern unsigned char SortTableNum(Table*, char*);
extern unsigned char SortTableNumInvers(Table*, size_t);
extern unsigned char SortTableNumInvers(Table*, char*);
extern char** NewTable(Table*, size_t);
